"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.process = process;

var _reactNative = require("react-native");

var _mediaquery = require("./mediaquery.js");

var _mediaquery2 = _interopRequireDefault(_mediaquery);

var _deepmerge = require("deepmerge");

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _microMemoize = require("micro-memoize");

var _microMemoize2 = _interopRequireDefault(_microMemoize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PREFIX = "@media";

function isMediaQuery(str) {
  return typeof str === "string" && str.indexOf(PREFIX) === 0;
}

function filterMq(obj) {
  return Object.keys(obj).filter(function (key) {
    return isMediaQuery(key);
  });
}

function filterNonMq(obj) {
  return Object.keys(obj).filter(function (key) {
    return !isMediaQuery(key);
  }).reduce(function (out, key) {
    out[key] = obj[key];
    return out;
  }, {});
}

var mFilterMq = (0, _microMemoize2.default)(filterMq);
var mFilterNonMq = (0, _microMemoize2.default)(filterNonMq);

function process(obj, matchObject) {
  var mqKeys = mFilterMq(obj);
  var res = mFilterNonMq(obj);

  mqKeys.forEach(function (key) {
    if (/^@media\s+(not\s+)?(ios|android|dom|macos|web|windows)/i.test(key)) {
      matchObject.type = _reactNative.Platform.OS;
    } else {
      matchObject.type = "screen";
    }

    var isMatch = _mediaquery2.default.match(obj.__mediaQueries[key], matchObject);
    if (isMatch) {
      res = (0, _deepmerge2.default)(res, obj[key]);
    }
  });

  return res;
}